/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "overworld.h"
#include "chunk.h"
#include "display/render.h"

uint16_t OVERWORLD_CAMERA_X = 0;
int8_t OVERWORLD_CAMERA_SUB_X = 0;
uint16_t OVERWORLD_CAMERA_Y = 0;
int8_t OVERWORLD_CAMERA_SUB_Y = 0;

void overworldInit(void) {
  OVERWORLD_CAMERA_X = 0;
  OVERWORLD_CAMERA_SUB_X = 0;
  OVERWORLD_CAMERA_Y = 0;
  OVERWORLD_CAMERA_SUB_Y = 0;

  chunkMapInit();
}

void overworldUpdate() {  
  while(OVERWORLD_CAMERA_SUB_X >= TILE_WIDTH) {
    OVERWORLD_CAMERA_SUB_X -= TILE_WIDTH;
    OVERWORLD_CAMERA_X++;
  }

  while(OVERWORLD_CAMERA_SUB_X < 0) {
    OVERWORLD_CAMERA_SUB_X += TILE_WIDTH;
    OVERWORLD_CAMERA_X--;
  }
  
  while(OVERWORLD_CAMERA_SUB_Y >= TILE_HEIGHT) {
    OVERWORLD_CAMERA_SUB_Y -= TILE_HEIGHT;
    OVERWORLD_CAMERA_Y++;
  }

  while(OVERWORLD_CAMERA_SUB_Y < 0) {
    OVERWORLD_CAMERA_SUB_Y += TILE_HEIGHT;
    OVERWORLD_CAMERA_Y--;
  }

  chunkMapSetPosition(
    (OVERWORLD_CAMERA_X - (RENDER_WIDTH / 2 / TILE_WIDTH)) / CHUNK_WIDTH,
    (OVERWORLD_CAMERA_Y - (RENDER_HEIGHT / 2 / TILE_HEIGHT)) / CHUNK_HEIGHT
  );
}